﻿namespace IRaCIS.Application.Contracts
{
    public class TrialExperienceCommand
    {
        public Guid? Id { get; set; }

        public Guid DoctorId { get; set; }

        public Guid? PhaseId { get; set; }

        public DateTime? StartTime { get; set; }

        public DateTime? EndTime { get; set; }

        public string EvaluationContent { get; set; } = String.Empty;

        public int VisitReadingCount { get; set; }

        //public string Term { get; set; }

        //public string EvaluationCriteria { get; set; }

        public List<Guid> EvaluationCriteriaIdList { get; set; } = new List<Guid>();


    }

    public class TrialExperienceListDTO: TrialExperienceCommand
    {
        public string Phase { get; set; } = String.Empty;

        public List<string> EvaluationCriteriaList { get; set; } = new List<string>();

    }

    //public class EvaluationCriteriaDTO
    //{
    //    public Guid EvaluationCriteriaId { get; set; }
    //    public string EvaluationCriteria { get; set; }
    //}


    public class TrialExperienceModel : GcpAndOtherExperienceDTO
    {
        public List<TrialExperienceListDTO> ClinicalTrialExperienceList = new List<TrialExperienceListDTO>();

        public string ExpiryDateStr { get; set; } = string.Empty;
        public string GCPFullPath { get; set; } = String.Empty;

    }


    public class GcpAndOtherExperienceDTO
    {
        public Guid Id { get; set; }

        public int GCP { get; set; }

        public Guid? GCPId { get; set; }

        public string OtherClinicalExperience { get; set; }=String.Empty;
        public string OtherClinicalExperienceCN { get; set; } = String.Empty;

        public string Type { get; set; } = string.Empty;

        public string Path { get; set; } = string.Empty;

        public string FileName { get; set; } = string.Empty;

    }

    public class GCPExperienceCommand
    {
        public Guid Id { get; set; }
        public int GCP { get; set; }

        public Guid? GCPId { get; set; } 
    }

    public class ClinicalExperienceCommand
    {
        public Guid DoctorId { get; set; }

        public string OtherClinicalExperience { get; set; } = String.Empty;
        public string OtherClinicalExperienceCN { get; set; } = String.Empty;
    }
}