using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("TrialExperience")]
    public partial class TrialExperience : Entity, IAuditUpdate, IAuditAdd
    {

        public List<TrialExperienceCriteria> ExperienceCriteriaList { get; set; }
        

        public Guid DoctorId { get; set; }

        //[StringLength(100)]
        //public string Term { get; set; }
        //[StringLength(100)]
        //public string EvaluationCriteria { get; set; }

        public Guid? PhaseId { get; set; }

        public Dictionary Phase { get; set; }

        [StringLength(512)]
        public string EvaluationContent { get; set; }

        public Guid CreateUserId { get; set; }
        public DateTime CreateTime { get; set; } = DateTime.Now;
        public Guid UpdateUserId { get; set; }
        public DateTime UpdateTime { get; set; }

        public int VisitReadingCount { get; set; }

        public DateTime? StartTime { get; set; }

        public DateTime? EndTime { get; set; }
    }
}
