using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace IRaCIS.Core.Domain.Models
{
    [Table("TrialStatus")]
    public partial class TrialStatusDetail : Entity, IAuditAdd
    {
        public virtual ICollection<EnrollDetail> IntoGroupDetails { get; set; }
        public TrialStatusDetail()
        {
            IntoGroupDetails = new HashSet<EnrollDetail>();
        }
        [JsonIgnore]
        public Trial Trial { get; set; }

        public Guid TrialId { get; set; }



        public int TrialStatus { get; set; }

        [StringLength(100)]
        public string Memo { get; set; } = string.Empty;

        public int OptUserType { get; set; }

        public Guid CreateUserId { get; set; }

        public DateTime CreateTime { get; set; }


    }
}
